#include "QUICException.h"
#include <sstream>

QUICException::QUICException(const char * file, QUIC::Int line, const char * error)
: exception()
{
	std::stringstream ss;
	ss<<file<<"("<<line<<") : "<<error<<std::endl;
	msg = ss.str();
}

QUICException::QUICException(const char * file, QUIC::Int line, cudaError error)
: exception()
{
	std::stringstream ss;
	ss<<file<<"("<<line<<") : CUDA error : "<<cudaGetErrorString(error)<<"."<<std::endl;
	msg = ss.str();
}

QUICException::QUICException(const char * file, QUIC::Int line, culaStatus error)
: exception()
{
	std::stringstream ss;
	ss<<file<<"("<<line<<") : CULA error : "<<culaGetStatusString(error)<<"."<<std::endl;
	msg = ss.str();
}