#ifndef TYPE

#define TYPE float
#include "explicit.h"
#undef TYPE
#define TYPE double
#include "explicit.h"
#undef TYPE

#else

#ifdef __CUDACC__

#define MATRIX QUIC::MatrixGPU<TYPE>
template void gpuCosines<TYPE>(const QUIC::MatrixGPU<TYPE>& A, TYPE * ARowNorms, QUIC::Uint * rows, const QUIC::Uint& nRows, const QUIC::Uint& splitRowId, TYPE * result, TYPE& cMin, TYPE& cMax, TYPE * minBuffer, TYPE * maxBuffer);
template QUIC::Uint gpuLabelRows<TYPE>(TYPE * cosines, const QUIC::Uint& nRows, const TYPE& cMin, const TYPE& cMax, QUIC::Uint * labels, QUIC::Uint& blockSize, QUIC::Uint& nBlocks);
template void gpuRowMeans<TYPE>(const QUIC::MatrixGPU<TYPE>& A, QUIC::Uint * rows, const QUIC::Uint& nRows, QUIC::Uint * labels, TYPE * leftMean, TYPE * rightMean, TYPE * scratch, const QUIC::Uint& scratchPitch); 

#else

#define MATRIX QUIC::Matrix<TYPE>
template QUIC::Uint cpuLabelRows<TYPE>(TYPE * cosines, const QUIC::Uint& nRows, const TYPE& cMin, const TYPE& cMax, QUIC::Uint * labels, QUIC::Uint& blockSize, QUIC::Uint& nBlocks);
template bool extractSVDFromProjection<QUIC::MatrixGPU<TYPE>, TYPE>(const QUIC::MatrixGPU<TYPE>& AVhat, const QUIC::MatrixGPU<TYPE>& VhatT, QUIC::MatrixGPU<TYPE> * U, QUIC::MatrixGPU<TYPE> * S, QUIC::MatrixGPU<TYPE> * VT, TYPE * scratch, const size_t& scratchPitch);
template bool extractSVDFromProjection<QUIC::Matrix<TYPE>, TYPE>(const QUIC::Matrix<TYPE>& AVhat, const QUIC::Matrix<TYPE>& VhatT, QUIC::Matrix<TYPE> * U, QUIC::Matrix<TYPE> * S, QUIC::Matrix<TYPE> * VT, TYPE * scratch, const size_t& scratchPitch);

#endif

template void matrixSqrt<TYPE>(MATRIX& m);
template void diagDivR<TYPE>(const MATRIX& A, const MATRIX& v, MATRIX& B);
template void diagDivL<TYPE>(const MATRIX& A, const MATRIX& v, MATRIX& B);
template void vectorMul<TYPE>(const MATRIX& x, MATRIX& y);
template void rowNorms<TYPE>(const MATRIX& A, const bool& square, TYPE * result);

#undef MATRIX

#endif