#pragma once

#define PROFILE

#ifdef PROFILE

#include <iostream>

typedef enum {PROJECTION = 0, PROJECTION_MUL, PROJECTION_NORM, ROW_NORMS, ROW_MEAN, ORTHOGONALIZATION, COSINES, SVD, SQRT, DIAG_DIV, MUL, REALLOCATION, COPY_H2D, COPY_D2H, BUILDING_TREE, EXTRACTING_SVD, NUM_TIMERS} TimerId;
typedef enum {CPU = 0, GPU, NUM_TIMER_TYPES} TimerType;

void startTimer(const TimerId& id, const TimerType& type);
void stopTimer(const TimerId& id, const TimerType& type);
void printTimers(bool printCPU, bool printGPU, std::ostream& ost);
void resetTimers();

#define START_TIMER(id, type) startTimer(id, type)
#define STOP_TIMER(id, type) stopTimer(id, type)
#define PRINT_TIMERS(t, ost) printTimers(((t) & (1 << CPU)) != 0, ((t) & (1 << GPU)) != 0, ost)
#define RESET_TIMERS() ::resetTimers();

#else

#define START_TIMER(id, type)
#define STOP_TIMER(id, type)
#define PRINT_TIMERS(t)
#define RESET_TIMERS()

#endif