#include "QUIC.h"

using namespace QUIC;

template <typename Float>
class MxArrayAllocator : public QUIC::MatAllocator<Float>
{
public:
	typedef typename QUIC::MatAllocator<Float>::size_type size_type;
	typedef typename QUIC::MatAllocator<Float>::pitched_pointer pitched_pointer;
	MxArrayAllocator();
	pitched_pointer allocate(size_type w, size_type h);
	void deallocate(pitched_pointer p, size_type w, size_type h);
	mxArray * A;
	static mxClassID classId;
};

template <typename Float>
inline MxArrayAllocator<Float>::MxArrayAllocator()
: A(NULL)
{}

template <typename Float>
inline typename MxArrayAllocator<Float>::pitched_pointer MxArrayAllocator<Float>::allocate(size_type w, size_type h)
{
	if (A) mxDestroyArray(A);
	A = mxCreateNumericMatrix(w, h, classId, mxREAL);
	mexMakeArrayPersistent(A);
	pitched_pointer p;
	p.pitch = w*sizeof(Float);
	p.addr = reinterpret_cast<Float *>(mxGetData(A));
	return p;
}

template <typename Float>
inline void MxArrayAllocator<Float>::deallocate(pitched_pointer p, size_type w, size_type h)
{}

template <>
mxClassID MxArrayAllocator<float>::classId = mxSINGLE_CLASS;

template <>
mxClassID MxArrayAllocator<double>::classId = mxDOUBLE_CLASS;