#include "QUIC.h"

using namespace QUIC;
using namespace std;

inline void invalidValue(const string& argName)
{
	stringstream ss;
	ss<<"Invalid value for parameter '"<<argName<<"'";
	mexErrMsgTxt(ss.str().c_str());
}

inline void mexQUICError()
{
	if (checkError())
	{
		shutdownGPU();
		mexErrMsgTxt(getLastError()->c_str());
	}
}

inline void usageError()
{
	stringstream ss;
	ss<<"Usage: [U, S, VT] = QUICmex(version, orthogonalization method, A, epsilon, delta, nBlocks, 'profile' (optional))"<<endl
	  <<       "[U, S] = QUICmex(version, orthogonalization method, A, epsilon, delta, nBlocks, 'profile' (optional))"<<endl
	  <<       "S = QUICmex(version, orthogonalization method, A, epsilon, delta, nBlocks, 'profile' (optional))"<<endl
	  <<"version = 'CPU' or 'GPU'\northogonalization method = 'MGS', 'UGS', or 'BLOCK_MGS'\nn = number of basis vectors'";
	mexErrMsgTxt(ss.str().c_str());
}