function [ U, S, V ] = gpu_svd(A, maxrank, core) %mimic matlab svd using quic svd
A = single(full(A)); %single precision since my CULA install only has single precision
if(nargin < 3)
core = 'GPU';
end
method = 'UGS';
epsilon = 10^-12;
delta = 10^-12;
partitions = 1;
profile = 0;
if(nargin < 2)
    try
    [U, S, VT] = QUICmex(core,method,A,'epsilon',epsilon,'delta',delta,'partitions',partitions,'profile',profile);
    catch
        %hack of a lifetime
        [U, S, VT] = QUICmex(core,method,A,'epsilon',epsilon,'delta',delta,'partitions',partitions,'profile',profile);
    end
else
[U, S, VT] = QUICmex(core,method,A,'epsilon',epsilon,'delta',delta,'partitions',partitions,'maxrank',maxrank,'profile',profile);
end
V = VT';
S = diag(S);
U = double(U);
S = double(S);
V = double(V);
end

%tic;[u, s, vt] = svds(Z*Z',50);toc;norm(u*s*vt'-Z*Z','fro')
%tic;[u_g,s_g,v_g]=gpu_svd(Z*Z',50);toc;norm(u_g*s_g*v_g'-single(full(Z*Z')),'fro')