function saveBin(filename, M)
% saveBin(filename, M) 
% Saves the matrix M in the format for the freestanding
% QUIC test program.  The precision is determined by the
% precision of M.

	switch lower(class(M))
		case 'single'
			precision = 'float32';
		case 'double'
			precision = 'float64';
		otherwise
			error('Invalid data type');
	end
	f = fopen(filename, 'wb');
	fprintf(f, '%s', precision);
	fwrite(f, 0, 'uint8');
	fwrite(f, size(M), 'int32');
	fwrite(f, M', precision);
	fclose(f);

end
